Imports Microsoft.VisualBasic
Imports System
Imports System.Diagnostics ' Process object
Imports System.Threading ' Sleep()
Imports System.Windows.Automation ' add UIAutomationClient.dll & UIAutomationTypes.dll
' from C:\ProgramFiles\ReferenceAssemblies\Microsoft\Framework\v3.0\

Namespace Harness
  Friend Class Program
	Shared Sub Main(ByVal args() As String)
	  Try
		Console.WriteLine(Constants.vbLf & "Begin WPF UIAutomation test run" & Constants.vbLf)
		Console.WriteLine("Launching CryptoCalc application")
		Dim p As Process = Nothing
		p = Process.Start("..\..\..\CryptoCalc\bin\Debug\CryptoCalc.exe")

		Dim ct As Integer = 0
		Do
		  Console.WriteLine("Looking for CryptoCalc process. . . ")
		  ct += 1
		  Thread.Sleep(10)
		Loop While p Is Nothing AndAlso ct < 50

		If p Is Nothing Then
		  Throw New Exception("Failed to find CryptoCalc process")
		Else
		  Console.WriteLine("Found CryptoCalc process")
		End If

		Console.WriteLine(Constants.vbLf & "Getting Desktop")
		Dim aeDesktop As AutomationElement = Nothing
		aeDesktop = AutomationElement.RootElement
		If aeDesktop Is Nothing Then
		  Throw New Exception("Unable to get Desktop")
		Else
		  Console.WriteLine("Found Desktop" & Constants.vbLf)
		End If

		'Console.WriteLine("\nLooking for CryptoCalc main window. . . ");
		'AutomationElement aeCryptoCalc = null;
		'Thread.Sleep(5000);
		'aeCryptoCalc = AutomationElement.FromHandle(p.MainWindowHandle);
		'if (aeCryptoCalc == null)
		'  throw new Exception("Could not find the CryptoCalc window");
		'else
		'  Console.WriteLine("Found CryptoCalc main window");

		Dim aeCryptoCalc As AutomationElement = Nothing
		Dim numWaits As Integer = 0
		Do
		  Console.WriteLine("Looking for CryptoCalc main window. . . ")
		  aeCryptoCalc = aeDesktop.FindFirst(TreeScope.Children, New PropertyCondition(AutomationElement.NameProperty, "CryptoCalc"))
		  numWaits += 1
		  Thread.Sleep(200)
		Loop While aeCryptoCalc Is Nothing AndAlso numWaits < 50

		If aeCryptoCalc Is Nothing Then
		  Throw New Exception("Failed to find CryptoCalc main window")
		Else
		  Console.WriteLine("Found CryptoCalc main window")
		End If

		Console.WriteLine(Constants.vbLf & "Getting all user controls")
		Dim aeButton As AutomationElement = Nothing
		aeButton = aeCryptoCalc.FindFirst(TreeScope.Children, New PropertyCondition(AutomationElement.NameProperty, "Compute"))
		If aeButton Is Nothing Then
		  Throw New Exception("No compute button")
		Else
		  Console.WriteLine("Got Compute button")
		End If

		'aeTextBox1 = aeCryptoCalc.FindFirst(TreeScope.Children,
		'  new PropertyCondition(AutomationElement.AutomationIdProperty, "textBox1"));

		Dim aeAllTextBoxes As AutomationElementCollection = Nothing
		aeAllTextBoxes = aeCryptoCalc.FindAll(TreeScope.Children, New PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.Edit))
		If aeAllTextBoxes Is Nothing Then
		  Throw New Exception("No textboxes collection")
		Else
		  Console.WriteLine("Got textboxes collection")
		End If

		Dim aeTextBox1 As AutomationElement = Nothing
		Dim aeTextBox2 As AutomationElement = Nothing
		aeTextBox1 = aeAllTextBoxes(0)
		aeTextBox2 = aeAllTextBoxes(1)
		If aeTextBox1 Is Nothing OrElse aeTextBox2 Is Nothing Then
		  Throw New Exception("TextBox1 or TextBox2 not found")
		Else
		  Console.WriteLine("Got TextBox1 and TextBox2")
		End If

		Dim aeRadioButton3 As AutomationElement = Nothing
		aeRadioButton3 = aeCryptoCalc.FindFirst(TreeScope.Descendants, New PropertyCondition(AutomationElement.NameProperty, "DES Encrypt"))

		If aeRadioButton3 Is Nothing Then
		  Throw New Exception("No RadioButton")
		Else
		  Console.WriteLine("Got RadioButton3")
		End If

	   Console.WriteLine(Constants.vbLf & "Setting input to 'Hello1!'")
		Dim vpTextBox1 As ValuePattern = CType(aeTextBox1.GetCurrentPattern(ValuePattern.Pattern), ValuePattern)
		vpTextBox1.SetValue("Hello!")

		Console.WriteLine("Selecting 'DES Encrypt' ")
		Dim spSelectRadioButton3 As SelectionItemPattern = CType(aeRadioButton3.GetCurrentPattern(SelectionItemPattern.Pattern), SelectionItemPattern)
		spSelectRadioButton3.Select()

		Console.WriteLine(Constants.vbLf & "Clicking on Compute button")
		Dim ipClickButton1 As InvokePattern = CType(aeButton.GetCurrentPattern(InvokePattern.Pattern), InvokePattern)
		ipClickButton1.Invoke()
		Thread.Sleep(1500)

		Console.WriteLine(Constants.vbLf & "Checking TextBox2 for '91-1E-84-41-67-4B-FF-8F'")
		Dim tpTextBox2 As TextPattern = CType(aeTextBox2.GetCurrentPattern(TextPattern.Pattern), TextPattern)
		Dim result As String = tpTextBox2.DocumentRange.GetText(-1)

		If result = "91-1E-84-41-67-4B-FF-8F" Then
		  Console.WriteLine("Found it")
		  Console.WriteLine(Constants.vbLf & "Test scenario: Pass")
		Else
		  Console.WriteLine("Did not find it")
		  Console.WriteLine(Constants.vbLf & "Test scenario: *FAIL*")
		End If

		'Console.WriteLine("\nClosing application in 5 seconds");
		'Thread.Sleep(5000);
		'WindowPattern wpCloseWindow =
		'  (WindowPattern)aeCryptoCalc.GetCurrentPattern(WindowPattern.Pattern);
		'wpCloseWindow.Close();

		Console.WriteLine(Constants.vbLf & "Clicking on File-Exit item in 5 seconds")
		Thread.Sleep(5000)
		' Console.ReadLine(); // pause for screenshot

		Dim aeFile As AutomationElement = Nothing
		aeFile = aeCryptoCalc.FindFirst(TreeScope.Descendants, New PropertyCondition(AutomationElement.NameProperty, "File"))
		If aeFile Is Nothing Then
		  Throw New Exception("Could not find File menu")
		Else
		  Console.WriteLine("Got File menu")
		End If

		Console.WriteLine("Clicking on 'File'")
		Dim expClickFile As ExpandCollapsePattern = CType(aeFile.GetCurrentPattern(ExpandCollapsePattern.Pattern), ExpandCollapsePattern)
		expClickFile.Expand()
		Thread.Sleep(1000)

		Dim aeFileExit As AutomationElement = Nothing
		aeFileExit = aeCryptoCalc.FindFirst(TreeScope.Descendants, New PropertyCondition(AutomationElement.NameProperty, "Exit"))
		If aeFileExit Is Nothing Then
		  Throw New Exception("Could not find File-Exit")
		Else
		  Console.WriteLine("Got File-Exit")
		End If
		Thread.Sleep(1000)

		Dim ipFileExit As InvokePattern = CType(aeFileExit.GetCurrentPattern(InvokePattern.Pattern), InvokePattern)
		ipFileExit.Invoke()

		Console.WriteLine(Constants.vbLf & "End automation" & Constants.vbLf)
		Console.ReadLine()
	  Catch ex As Exception
		Console.WriteLine("Fatal: " & ex.Message)
		Console.ReadLine()
	  End Try

	End Sub ' Main()
  End Class ' class
End Namespace ' ns
